$(document).ready(function () {
    $("body").off('click').on("click", '.remove', remove);
    $("body").on("keyup change blur focus", ".qty, .rate, .amount,.discperc,.discamt,.vatperc", calDetail);
    $("body").on("keyup change blur focus", ".ldiscperc, .tvatperc, .totdisc, .totadv,.addpack,.addgst", mainCal);
//    $("body").on("focus blur change", ".vouchdt", getvoucher);
    $("body").on("change blur", ".party", getTrans);
    $("body").on("blur", '.cost', autoaddrow);
    $("body").on("change", '.paidby', chgType);
    $("body").on("change blur", '.itemname', itemModalShow);

//    $("body").on("keydown", 'td', updown);

    function getTrans() {
        var party = $(".party").val();
        $.post('get_trans.php', {party: party}, function (data) {
            $(".transporter").val(data).trigger("change");
        });
    }
    chgType();
    function chgType() {
        var paidby = $(".paidby").val();
        if (paidby == "C") {
            $(".totadv").attr("readonly", true);
            $(".totadv").val("0");
            mainCal();
        } else {
            $(".totadv").removeAttr("readonly", true);

        }
    }
//    function updown() {
//        var tr = $(this).closest('tr'),
//                newsrno = tr.find(".srno").val(),
//                srno = parseFloat(newsrno) - 2,
//                curcls = $(this).attr('class');
//
//        $(document).keydown(function (event) {
//            if (event.keyCode == 40) { // Down key maps to keycode `40`
//                if (curcls == 'p2') {
//                    $('#rate_' + newsrno).focus();
//                    $('#rate_' + newsrno).select();
//                } else if (curcls == 'p1') {
//                    $('#qty_' + newsrno).focus();
//                    $('#qty_' + newsrno).select();
//                }
//            }
//        });
//
//
//        $(document).keydown(function (event) {
//            if (event.keyCode == 38) { // Up key maps to keycode `38`
//                if (curcls == 'p2') {
//                    $('#rate_' + srno).focus();
//                    $('#rate_' + srno).select();
//                } else if (curcls == 'p1') {
//                    $('#qty_' + srno).focus();
//                    $('#qty_' + srno).select();
//                }
//            }
//        });
//    }


    $("#submit").click(function () {
        $("#submit").hide();
    });

    $("form").submit(function () {

        var party = $('.party').val(),
                godown = $('.godown').val(),
                totbillamt = $('.totbillamt').val(),
                valid = true;


        if (party == '') {
            var message = "Party Cannot Be Empty";
            alert(message);
            $("#submit").show();

            return false;
            valid = false;
        }
        if (godown == '') {
            var message = "Godown Cannot Be Empty";
            alert(message);
            $("#submit").show();

            return false;
            valid = false;
        }

        if (parseFloat(totbillamt) <= 0 || totbillamt == '') {
            var message = "Netamt Cannot zero";
            alert(message);
            $("#submit").show();

            return false;
            valid = false;
        }

        if (valid) {
            var isValid = true;

            if (isValid) {
                $("#submit").hide();
                $("#cancel").hide();

            }
        }
    });



    var canc_flag = $(".canc_flag").val();
    if (canc_flag != '') {
        $("#scancbill").hide();
        $("#hedit").hide();

    }


//    $("#hdelete").hide();


    $("#cancbill").click(function () {
        $("#cancmodel").modal('show');
    });

    function autoaddrow() {
        var ctr = $('#items').val();
        var tr = $(this).closest("tr");
        var srno = tr.find(".srno").val();
        if (srno == ctr) {
            AddRows();
        }
//        if ($(this).closest('tr').is(":last-child")) {
//            AddRows();
//        }
    }

    var lrno = $('.lrno').val();
    if (lrno != '') {
        $(".lrdetail").show();
    } else {
        $(".lrdetail").hide();
    }




    $(".lrtab").click(function () {
        $(".lrdetail").animate({
            height: 'toggle'
        });
    });

    function calDetail() {
        var tr = $(this).closest("tr"),
                cartqty = tr.find(".cartqty").val(),
                qty = tr.find(".qty").val(),
                totqty = cartqty * qty,
                rate = tr.find(".rate").val(),
                amount = (rate * qty).toFixed(2),
                discperc = tr.find(".discperc").val(),
                discamt = 0,
                vatperc = tr.find(".vatperc").val(),
                subtot = 0,
                total = 0,
                vat = 0;

        if (discperc > 0) {
            discamt = ((discperc * amount) / 100).toFixed(2);
        } else {
            discamt = tr.find(".discamt").val();
        }
        subtot = amount - discamt;
        if (vatperc > 0) {
            vat = ((vatperc * subtot) / 100).toFixed(2);
        } else {
            vat = 0;
        }
        total = (parseFloat(subtot) + parseFloat(vat)).toFixed(2);
        tr.find(".totqty").val(totqty);
        tr.find(".amount").val(amount);
        tr.find(".discamt").val(discamt);
        tr.find(".vat").val(vat);
        tr.find(".total").val(total);
        var totamt = 0,
                totdisc = 0,
                totvat = 0,
                tottotal = 0,
                totbal = 0,
                totalqty = 0,
                totadv = 0;
        $(".qty").each(function () {
            if (!isNaN(this.value) && this.value.length != 0) {
                totalqty += parseFloat(this.value);
            }
        });
        $(".totalqty").val(totalqty);

        $(".amount").each(function () {
            if (!isNaN(this.value) && this.value.length != 0) {
                totamt += parseFloat(this.value);
            }
        });
//        $(".discamt").each(function () {
//            if (!isNaN(this.value) && this.value.lenght != 0) {
//                totdisc += parseFloat(this.value);
//            }
//        });
//        $(".vat").each(function () {
//            if (!isNaN(this.value) && this.value.lenght != 0) {
//                totvat += parseFloat(this.value);
//            }
//        });
        $(".amount").each(function () {
            if (!isNaN(this.value) && this.value.lenght != 0) {
                tottotal += parseFloat(this.value);
            }
        });
        $(".totamt").val(totamt);

//        $(".tottotal").val(tottotal);
        mainCal();
    }
    function mainCal() {
        var tdiscperc = $(".ldiscperc").val(),
                vatperc = $(".tvatperc").val(),
                amount = $(".totamt").val(),
                addpack = $(".addpack").val(),
                addgst = $(".addgst").val(),
                totadv = $(".totadv").val(),
                discamt = 0, vat = 0,
                totbal = 0;
        if (tdiscperc > 0) {
            discamt = ((tdiscperc * amount) / 100).toFixed(2);
        } else {
            discamt = $(".totdisc").val();
        }
        var subtot = amount - discamt;
        if (vatperc > 0) {
            vat = ((vatperc * subtot) / 100).toFixed(2);
        } else {
            vat = 0;
        }
        var finamt = parseFloat(subtot) + parseFloat(vat) + parseFloat(addpack) + parseFloat(addgst),
                totbal = parseFloat(finamt) - parseFloat(totadv);
        $(".totdisc").val(discamt);
        $(".totvat").val(vat);
        $(".tottotal").val(finamt);
        $(".totbal").val(totbal);

    }


    $('#addnew').click(function () {
        AddRows();
    });
    function remove() {
        $(this).closest("tr").remove();
        calDetail();
        caltran();
        mainCal();
    }

    function AddRows() {
        var ctr = $('#items').val();
        var prodtype = $('.prodtype').val();
        var hide_check = "";
        if ($("#del_all").prop("checked")) {
            hide_check = 0;
        } else {
            hide_check = 1;
        }
        var focusFld = ".focusFld_" + ctr;
        var detail = ".fetchpart_" + ctr;

        ctr++;
        $('#items').val(ctr);
        $.post('sale_add.php', {ctr: ctr, hide: hide_check, prodtype: prodtype}, function (data) {
            $(data).appendTo('.tbody');
            $(detail).select2();

            $(focusFld).focus();
        });
    }


    function itemModalShow() {
        var tr = $(this).closest("tr"),
                srno = tr.find(".srno").val(),
                party = $(".cmbparty").val(),
                file = $(".file").val(),
                margin = srno * 2.5,
                rate = tr.find(".rate").val(),
                itemcode = tr.find(".itemname").val();
        $(".modal-content").css("margin-top", margin + "%");


        if (itemcode != '') {
            $.ajax({
                type: "POST",
                datatype: "json",
                url: "search_ibarcode.php",
                data: {itemcode: itemcode, file: file},
                success: function (response) {
                    var m = response;


                    if (rate <= 0) {
                        tr.find(".rate").val(m.rate);
                    } else {
                        tr.find(".rate").val(rate);

                    }


                    tr.find(".rate").val(m.rate);
                    tr.find(".stk").val(m.stk);

                    tr.find(".qty").focus();
                    tr.find(".qty").select();

                },
                error: function (request, textStatus, errorThrown) {

                }
            });

        }
    }


});